﻿Option Strict On

Imports Windows.Storage
Imports Bing.Maps
Imports Windows.UI.Popups
Imports System.Net.Http
Imports Windows.UI

Public NotInheritable Class BingMapsShowPage
    Inherits Page

    Const AppID As String = "qXDGISuxg67atI4gLyUd7jooKwQCGGcDhHivtN7RxokBQryudCudKCXedwS.FvYiWXW_kM8oo_5M"
    Dim myImageName As StorageFile
    Protected Overrides Async Sub OnNavigatedTo(e As Navigation.NavigationEventArgs)
        Try
            myImageName = DirectCast(e.Parameter, StorageFile)
            Dim result As String = myImageName.Path
            Dim myResult = IO.Path.GetFileNameWithoutExtension(result) & ".jpg"

            Dim myLatitude = myResult.Substring(21, 9)
            Dim myLongitude = myResult.Substring(31, 10)
          
            Dim myUri As String = String.Format("http://reverse.search.olp.yahooapis.jp/OpenLocalPlatform/V1/reverseGeoCoder?lat={0}&lon={1}&appid={2}", myLatitude, myLongitude, AppID)
            Dim myHttpClient As New HttpClient
            Dim resultAddress = Await myHttpClient.GetStringAsync(myUri)
            resultAddress = resultAddress.Replace("<YDF firstResultPosition=" & ChrW(34) & "1" & ChrW(34) & " totalResultsAvailable=" & ChrW(34) & "1" & ChrW(34) & " totalResultsReturned=" & ChrW(34) & "1" & ChrW(34) & " xmlns=" & ChrW(34) & "http://olp.yahooapis.jp/ydf/1.0" & ChrW(34) & ">", "<YDF>")

            Dim httpDoc As XElement = XElement.Parse(resultAddress)
            Dim myAddress = httpDoc.Descendants("Address").Value
       
            Dim myFolder = KnownFolders.PicturesLibrary
            Dim mySubFolder = Await myFolder.CreateFolderAsync("MemoryImage", CreationCollisionOption.OpenIfExists)
            Dim myPictureFile = Await mySubFolder.GetFileAsync(myResult)
            Dim myPicture = Await myPictureFile.OpenReadAsync
            Dim myBmp As New BitmapImage
            myBmp.SetSource(myPicture)

            myMap.Center = New Location(CDbl(myLatitude), CDbl(myLongitude))
        
            Dim myPin As New Pushpin
            myPin.Background = New SolidColorBrush(Colors.Crimson)
            Dim myStackPanel As New StackPanel
            myStackPanel.Margin = New Thickness(5)
            myStackPanel.Background = New SolidColorBrush(Colors.Navy)
            myStackPanel.Visibility = Xaml.Visibility.Collapsed
            Dim myTextBlock As New TextBlock
            myTextBlock.Foreground = New SolidColorBrush(Colors.Red)
            myTextBlock.FontSize = 24
            myTextBlock.Padding = New Thickness(10)
            myTextBlock.Text = myAddress & " 辺り"
            Dim myImage As New Image
            With myImage
                .Width = 160
                .Height = 120
                .Source = myBmp
            End With

            myStackPanel.Children.Add(myTextBlock)
            myStackPanel.Children.Add(myImage)
            MapLayer.SetPosition(myPin, New Location(CDbl(myLatitude), CDbl(myLongitude)))
            myMap.Children.Add(myPin)

            MapLayer.SetPosition(myStackPanel, New Location(CDbl(myLatitude), CDbl(myLongitude)))
            myMap.Children.Add(myStackPanel)

            AddHandler myPin.Tapped, Sub()
                                         myStackPanel.Visibility = Windows.UI.Xaml.Visibility.Visible
                                     End Sub

            AddHandler myStackPanel.Tapped, Sub()
                                                myStackPanel.Visibility = Windows.UI.Xaml.Visibility.Collapsed
                                            End Sub
        Catch
            ErrorShow()
        End Try
    End Sub

    Private Async Sub ErrorShow()
        Dim myMessage As New MessageDialog("GPSまたは位置情報取得機能が付いておりません。" & vbCrLf & "写真を撮った位置の表示はできません。" & vbCrLf & "GPSまたは位置情報取得機能の付いたPCでお試しください。")
        Await myMessage.ShowAsync
        Exit Sub
    End Sub
End Class
