﻿Imports Windows.Media.Capture
Imports Windows.Storage
Imports Windows.Media.MediaProperties
Imports Windows.Storage.Streams
Imports Windows.UI.Popups
Imports Windows.Devices.Geolocation

Public NotInheritable Class MainPage
    Inherits Page
    Dim myIndex As Integer

    Dim myPictureFiles As IReadOnlyList(Of IStorageFile)
    Dim myMediaCapture As New MediaCapture
    Dim Index As Integer
    Dim saveBmp As BitmapImage
    Dim myGeolocator As Geolocator
    Dim myLatitude As String
    Dim myLongitude As String
    Dim no As Integer = 0
    Protected Overrides Async Sub OnNavigatedTo(e As Navigation.NavigationEventArgs)
        Try
            Dim myFolder As StorageFolder = Windows.Storage.KnownFolders.PicturesLibrary
            Dim mySubFolder = Await myFolder.CreateFolderAsync("MemoryImage", CreationCollisionOption.OpenIfExists)
            Dim imgFile = Await mySubFolder.GetFilesAsync
            If imgFile.Count > 0 Then
                positionButton.IsEnabled = True
            Else
                positionButton.IsEnabled = False
            End If

            If myGeolocator Is Nothing = True Then
                myGeolocator = New Geolocator
                myGeolocator.DesiredAccuracy = PositionAccuracy.High
            End If


            AddHandler myGeolocator.PositionChanged, AddressOf myGeolocator_PositionChanged
            GridView1.Visibility = Windows.UI.Xaml.Visibility.Visible

            Await myMediaCapture.InitializeAsync()
            CaptureElement1.Source = myMediaCapture
            Await myMediaCapture.StartPreviewAsync
            AddPhoto()
        Catch
            messageTextBlock.Text = "カメラが装備されておりません。"
            shutterButton.IsEnabled = False
            positionButton.IsEnabled = False
            Exit Sub
        End Try
    End Sub

    Protected Overrides Sub OnNavigatedFrom(e As Navigation.NavigationEventArgs)
        RemoveHandler myGeolocator.PositionChanged, AddressOf myGeolocator_PositionChanged
        MyBase.OnNavigatedFrom(e)
    End Sub

    Private Sub myGeolocator_PositionChanged(sender As Geolocator, args As PositionChangedEventArgs)
        Dim myCoordinate As Geocoordinate = args.Position.Coordinate
        myLatitude = myCoordinate.Latitude
        myLongitude = myCoordinate.Longitude
    End Sub

    Private Async Sub AddPhoto()
        no = 0
        Try
            Dim myFolder As StorageFolder = Windows.Storage.KnownFolders.PicturesLibrary
            Dim mySubFolder = Await myFolder.CreateFolderAsync("MemoryImage", CreationCollisionOption.OpenIfExists)
            myPictureFiles = Await mySubFolder.GetFilesAsync()
            If myPictureFiles.Count = 0 Then Image1.Source = Nothing
            For Each myPhotoFile In myPictureFiles
                Dim bmp As New BitmapImage
                bmp.SetSource(Await myPhotoFile.OpenSequentialReadAsync)
                Dim myImage As Image = New Image
                myImage.Width = 160
                myImage.Height = 120
                myImage.Source = bmp

                Dim myFileName As New TextBlock
                myFileName.Text = myPhotoFile.Name.Substring(0, 20)
                myFileName.FontSize = 10
                myFileName.HorizontalAlignment = Windows.UI.Xaml.HorizontalAlignment.Center

                Dim myButton As New Button
                With myButton
                    .Content = "削除"
                    .FontSize = 18
                    .Tag = no.ToString
                    .HorizontalAlignment = Windows.UI.Xaml.HorizontalAlignment.Center
                End With
                Dim myStackPanel As StackPanel = New StackPanel
                myStackPanel.Margin = New Thickness(3)
                myStackPanel.Children.Add(myImage)
                myStackPanel.Children.Add(myFileName)
                myStackPanel.Children.Add(myButton)
                GridView1.Items.Add(myStackPanel)


                AddHandler myButton.Click, Async Sub(delSender As Object, delArgs As RoutedEventArgs)
                                               Dim myNo As String = DirectCast(delSender, Button).Tag
                                               Dim myIndex As Integer = CInt(myNo)
                                               Await myPictureFiles(myIndex).DeleteAsync
                                               Dim myMessage As New MessageDialog("削除しました。")
                                               Await myMessage.ShowAsync
                                               GridView1.Items.Clear()
                                               no = 0
                                               AddPhoto()
                                           End Sub
                no += 1
            Next
            myPictureFiles = Await mySubFolder.GetFilesAsync()
            Index = myPictureFiles.Count
            If Index = 0 Then
                Exit Sub
            Else
                GridView1.SelectedIndex = Index - 1
                GridView1.ScrollIntoView(GridView1.SelectedItem)
            End If
        Catch
            Exit Sub
        End Try

    End Sub

    Private Sub shutterButton_Click(sender As Object, e As RoutedEventArgs) Handles shutterButton.Click
        CountdownControl1.Visibility = Windows.UI.Xaml.Visibility.Visible
        messageTextBlock.Text = String.Empty
        CountdownControl1.Seconds = 5
    End Sub

    Private Sub CountdownControl1_CountdownComplete(sender As Object, e As RoutedEventArgs) Handles CountdownControl1.CountdownComplete
        MediaElement1.Play()
        messageTextBlock.Text = "ピクチャライブラリのMemoryImageフォルダに保存しました。"
        CountdownControl1.Visibility = Windows.UI.Xaml.Visibility.Collapsed
        positionButton.IsEnabled = True
        PhotoSave()
    End Sub

    Private Async Sub PhotoSave()
        Dim myFolder As StorageFolder = Windows.Storage.KnownFolders.PicturesLibrary
        Dim mySubFolder = Await myFolder.CreateFolderAsync("MemoryImage", CreationCollisionOption.OpenIfExists)

        Dim myFile As StorageFile = Await mySubFolder.CreateFileAsync(DateTime.Now.ToString("yyyy年MM月dd日HH時mm分ss秒") & "-" & myLatitude & "-" & myLongitude & ".jpg")
        Dim myImageEncodingProperty As New ImageEncodingProperties
        myImageEncodingProperty.Subtype = "jpeg"
        myImageEncodingProperty.Width = 640
        myImageEncodingProperty.Height = 480
        Await myMediaCapture.CapturePhotoToStorageFileAsync(myImageEncodingProperty, myFile)

        myPictureFiles = Await mySubFolder.GetFilesAsync()
        Index = myPictureFiles.Count
        saveBmp = New BitmapImage
        saveBmp.SetSource(Await myPictureFiles(Index - 1).OpenReadAsync)
        Image1.Source = saveBmp
        positionButton.IsEnabled = True
    End Sub

    Private Sub MediaElement1_MediaEnded(sender As Object, e As RoutedEventArgs) Handles MediaElement1.MediaEnded
        Dim myPos As New TimeSpan(0, 0, 0)
        messageTextBlock.Text = "ピクチャライブラリのMemoryImageフォルダに保存しました。"
        MediaElement1.Position = myPos
        GridView1.Items.Clear()
        AddPhoto()
    End Sub

    Private Async Sub GridView1_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles GridView1.SelectionChanged
        myIndex = GridView1.SelectedIndex
        If myIndex < 0 Then
            Exit Sub
        Else
            Dim myFolder As StorageFolder = Windows.Storage.KnownFolders.PicturesLibrary
            Dim mySubFolder = Await myFolder.CreateFolderAsync("MemoryImage", CreationCollisionOption.OpenIfExists)
            myPictureFiles = Await mySubFolder.GetFilesAsync()
            saveBmp = New BitmapImage
            saveBmp.SetSource(Await myPictureFiles(myIndex).OpenReadAsync)
            Image1.Source = saveBmp
        End If
    End Sub


    Private Sub backButton_Click(sender As Object, e As RoutedEventArgs) Handles backButton.Click
        GridView1.Visibility = Windows.UI.Xaml.Visibility.Visible
        myFrame.Visibility = Windows.UI.Xaml.Visibility.Collapsed
    End Sub

    Private Async Sub positionButton_Click(sender As Object, e As RoutedEventArgs) Handles positionButton.Click
        myFrame.Visibility = Windows.UI.Xaml.Visibility.Visible
        GridView1.Visibility = Windows.UI.Xaml.Visibility.Collapsed
        Dim myFolder As StorageFolder = Windows.Storage.KnownFolders.PicturesLibrary
        Dim mySubFolder = Await myFolder.CreateFolderAsync("MemoryImage", CreationCollisionOption.OpenIfExists)
        Dim myImageFiles = Await mySubFolder.GetFilesAsync
        Dim myImageName = myImageFiles(GridView1.SelectedIndex)
        myFrame.Navigate(GetType(BingMapsShowPage), myImageName)
    End Sub
End Class

